#!/usr/bin/python

# Template for 2nd programming assignment
# DB2 - WS 2015/16

# IMPORTS:

# module to read linewise from standard input
import fileinput

# to access command-line parameter and standard input (see below)
import sys


# this is the main function
def main():
    # initialize a list
    # NOTE: this is similar to a Vector in Java
    inputtuples = []

    # Loop over each line from standard input
    # NOTE: In python indention matters. We follow Python's style guide in
    # this example, which uses 4 whitespace characters for an indention level.
    for line in fileinput.input("-"):

        # There is a newline at the end of each line - get rid of it
        line_stripped = line.strip()

        # add to tracklist
        inputtuples.append(line_stripped)


    # assign first command-line argument to variable algo
    # NOTE: as in Java, the first element of an array (list in python)
    # is accessed via index 0. However, sys.argv[0] contains the name python
    # script, not the first cmdline parameter
    algo = sys.argv[1]

    # decide which algorithm to execute
    if algo == "byte":
        header_fields = byte_scheme(inputtuples)
    elif algo == "word":
        header_fields = word_scheme(inputtuples)
    else:
        raise Exception("Unknown scheme: %s" % algo)

    # Output
    for header_field in header_fields:
        # Print header_field size
        print "%d:%d" % tuple(header_field)



# Function implementing the byte scheme
def byte_scheme(inputtuples):

    # initialize blocksize pointer to size (in bytes) of the page
    blocksize = 512

    # the field should contain pairs of integers, where the first one specifies the size of the field in bits
    # while the second one contains the value

    header_fields = []

    # nr of tuples field
    header_fields.append([ 9, 0 ])

    # initialize free space pointer
    header_fields.append([ 9, blocksize ])

    # initialize tuple_start_pos with blocksize
    tuple_start_pos = blocksize

    for i in range(0, len(inputtuples)):

        # compute start pos of tuple
        tuple_start_pos = tuple_start_pos - len(inputtuples[i])

        # we use byte addressing so we do not have to correct the start address

        header_fields.append( [ 9, len(inputtuples[i]) ] )
        header_fields.append( [ 9, tuple_start_pos ])

        # update count of tuples
        header_fields[0][1] += 1

        # update free space pointer
        header_fields[1][1] = tuple_start_pos - 1

    return header_fields


# Function implementing word scheme
def word_scheme(inputtuples):

    raise Exception("Word Addressing scheme not implemented")


# the main function needs to be called explicitly
if __name__ == "__main__":
    main()
